//+------------------------------------------------------------------+
//|                                                  Daily_Waist.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

#property indicator_buffers 1
#property indicator_color1  Yellow
#property indicator_width1 0

extern bool LineTEXT =true;

//---- input parameters

//---- buffers
double WBuffer[];
string Pivot = "Waist";
double YesterdayOpen, YesterdayClose, x,RANGE,WAIST,OPEN;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete("Waist");

	//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{  string short_name;
	//---- indicator line
	SetIndexStyle(0, DRAW_LINE);
	
	
	SetIndexBuffer(0, WBuffer);
	
	 short_name="Waist";
	 
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
	//----
	SetIndexDrawBegin(0,1);
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
	
	if (LineTEXT == true)
	{
	ObjectCreate("Waist", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Waist", "                                         WAIST", 7, "Arial",Silver);
	
   }
	//----
	return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
 {
  int lastbar;
   int counted_bars= IndicatorCounted();
   
   if (counted_bars>0) counted_bars--;
   lastbar = Bars-counted_bars;	
   
   
   
	int limit, i;

	//---- indicator calculation
	if(counted_bars == 0)
	{
		x = Period();
		if(x > 240) 
			return(-1);

	}
	if(counted_bars < 0) 
		return(-1);
	//---- last counted bar will be recounted
	//   if(counted_bars>0) counted_bars--;
	limit = (Bars-counted_bars)-1;
	//----
	for(i=limit; i>=0; i--){
	if (TimeDayOfWeek(Time[i+1])!=0)//Monday
	 
		if(Open[i+1] > YesterdayOpen) 
			YesterdayOpen = Open[i+1];
		//----
		if(Close[i+1] < YesterdayClose) 
			YesterdayClose=Close[i+1];
			if (TimeDay(Time[i])!= TimeDay(Time[i+1]))
		{
		   WBuffer[i+1] = EMPTY_VALUE;
		   
		 		
			WAIST = (YesterdayOpen+Close[i+1])/2; 
		   OPEN = Open[i];
			
		
			YesterdayClose = Close[i]; 
			YesterdayOpen = Open[i];
			
         ObjectMove("Waist", 0, Time[i+2], WAIST);
         ObjectMove("Open", 0, Time[i+2], OPEN);
       
		}
		WBuffer[i] = WAIST;
	}

	//----
	return(0);

}
//+------------------------------------------------------------------+

